#ifndef FB_SERV_H
#define FB_SERV_H

/* given by make */
/* #define VERSION       "0.0.3" */
/* #define PACKAGE       "frozen bubble server" */

#define COPYRIGHT     PACKAGE " v" VERSION "\nCopyright (C) 2002-2003 Charles Longeau (chl at tuxfamily.org)\n"
#define HOMEPAGE      "http://chl.tuxfamily.org/frozen-bubble/\n\n"

#define MAX_NICK_SIZE 64
#define MAX_PLAYERS   10
#define BUFFER_SIZE   2048
#define SERVER_PORT   9876
#define BOARD_WIDTH   7
#define BOARD_HEIGHT  15
#define NOPLAYER      -1

#define TALK_CMD           "" /* default*/
#define NICK_CMD           "/nick "
#define START_CMD          "/start"
#define LIST_CMD           "/list"
#define NEW_CMD            "/new"
#define QUIT_CMD           "/quit"
#define PLAYER_STATUS_CMD  "/playerstatus "
#define PLAYER_MALUS_CMD   "/playermalus "
#define PLAYER_SYNCH_CMD   "/playersynch "
#define PLAYER_BOARD_CMD   "/playerboard "

#define MSG_WELCOME           "Welcome to the frozen bubble server, "
#define MSG_HELP              "type /nick <nickname> to change your nick\ntype /quit to quit\ntype whatever to chat with other players\n"
#define MSG_WELCOME_MASTER    "You are the master, here are your special commands :\ntype /new to start a new game\ntype /list to list current players\n"
#define MSG_NICK_ACCEPTED     "Nick Accepted\n"
#define MSG_NOT_MASTER        "Only master can do that\n"
#define MSG_INVALID_CMD       "Invalid command ! Type /quit to quit\n"
#define MSG_GAME_START        "Game started\n"
#define MSG_TYPE_START        "Master has begin a new game, type /start to begin\n"
#define MSG_SERVER_FULL       "Server Full or already playing a game, please retry later\n"
#define MSG_WAITING_EVERYBODY "Waiting everybody to type /start\n"

#define SERVER_STATE_READY             0
#define SERVER_STATE_ACCEPTING_PLAYERS 1
#define SERVER_STATE_START_GAME        2
#define SERVER_STATE_PLAY              3
#define SERVER_STATE_END_GAME          4
#define SERVER_STATE_CLOSING           5

typedef struct state_player_s {
        int player_id; /* If == -1 => no player */
        char nickname[MAX_NICK_SIZE];
        int tab_balls[BOARD_WIDTH][BOARD_HEIGHT];
        int sock_fd;
        int malus;
        int state_game;
        int ready;
} state_player_t;

void init_tab_state_players(void);
void write_to_socket(int sock_fd, char *message);
void write_to_all_socket_except_one(int sock_fd, char *message);
void write_to_all_socket(char *message);
void list_players(int sock_fd);
int get_free_id(void);
void *thread_player_manager(void *args);
void *thread_serv(void *args);

#endif /* FB_SERV_H */
